module SkypeCheck
  class << self
    attr_accessor :configuration

    def configuration
      @configuration || configure
    end
  
    def configure
      @configuration = Configuration.new
      yield(configuration) if block_given?
      @configuration
    end
  end


  class Configuration
    attr_accessor :username_validator_endpoint

    DEFAULT_ENDPOINT = 'https://login.skype.com/json/validator'
 

    def username_validator_endpoint
      @username_validator_endpoint || DEFAULT_ENDPOINT
    end
    
  end
end
